//+------------------------------------------------------------------+
//|                                                WPR_MA_2line.mq4 |
//|                      Copyright  2011, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "2011 Vladimir Borisov aka Prolon"
#property link      "e-mail: kad10lond@rambler.ru"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 Blue
#property indicator_color2 Red
#property indicator_color3 Green
#property indicator_level1 0
#property indicator_level2 60
#property indicator_level3 -60
#property indicator_maximum 100
#property indicator_minimum -100
//---- input parameters

extern int WPR_Period= 20;
extern int ma_period=20;
extern int width_cannel=33;
extern int max_cannel =120;
extern int L = 10;
int Limit=5000;
int MA_Mode  =0;
double MAWPR[],UpCannel[],DownCannel[];
double WPR[]; 
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init() {
   IndicatorBuffers(4);
   SetIndexStyle(0,DRAW_LINE);   
   SetIndexDrawBegin(0,WPR_Period); 
   SetIndexBuffer(0,MAWPR);
    
   IndicatorShortName("MA_WPR("+WPR_Period+")");
   SetIndexLabel(0,"MA(WPR)");
   
   SetIndexStyle(1,DRAW_LINE);   
   SetIndexBuffer(1,UpCannel);
   SetIndexStyle(2,DRAW_LINE);   
   SetIndexBuffer(2,DownCannel);
   SetIndexBuffer(3,WPR);  

   return(0); }

//+------------------------------------------------------------------+
int start() {
   int limit;
   int counted_bars=IndicatorCounted();
   int i;
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   if (limit>Limit && Limit>0) limit = Limit;
   for (i = limit;i>=0;i--) WPR[i] = (iWPR(Symbol(),Period(),WPR_Period,i)+50.0)*2.0;
   for (i = limit;i>=0;i--){
       MAWPR[i] = iMAOnArray(WPR,0,ma_period,0,MA_Mode,i);
       if(MAWPR[i]-L>UpCannel[i+1]){
         UpCannel[i]=MAWPR[i]-L;
         DownCannel[i]=UpCannel[i]-width_cannel;
       }else{
          if(MAWPR[i]+L<DownCannel[i+1]){
            DownCannel[i]=MAWPR[i]+L;
            UpCannel[i]=DownCannel[i]+width_cannel;
          }else{
             UpCannel[i]=UpCannel[i+1];
             DownCannel[i]=DownCannel[i+1];
          }
       }
       if(UpCannel[i]>max_cannel*0.5)UpCannel[i]=max_cannel*0.5;
       if(DownCannel[i]<-max_cannel*0.5)DownCannel[i]= -max_cannel*0.5;
   }
         
   return(0);  
}